VehicleInspector = {};

VehicleInspector.metadata = {
	interface = " FS17 1.x",
	title = " VehicleInspector",
	notes = " Zeigt/Ändert Vehicle Informationen/Bestände und vieles mehr in einem PDA Hud an",
	author = " (by HappyLooser)",
	version = " v1.35 Beta",
	datum = " 05.11.2016",
	update = " 15.10.2017",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

VehicleInspector.modDir = g_currentModDirectory;
VehicleInspector.settingsDir = getUserProfileAppPath();	
function VehicleInspector:loadMap(name)		
	print("---loading".. tostring(VehicleInspector.metadata.title).. tostring(VehicleInspector.metadata.version).. tostring(VehicleInspector.metadata.author).. "---")	
	VehicleInspector.testTimer = 0;
	VehicleInspector.pathSavegame = "";
	VehicleInspector.mapName = "";
	VehicleInspector.pathSavegame = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex);
	VehicleInspector.language = "_".. string.lower(g_languageShort);
	VehicleInspector.isMp = g_currentMission.missionDynamicInfo.isMultiplayer;	
	VehicleInspector.loadDetiServer = false;
	VehicleInspector.loadHostServer = false;
	if VehicleInspector.isMp and g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then VehicleInspector.loadDetiServer = true;end;
	if VehicleInspector.isMp and g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo == nil then VehicleInspector.loadHostServer = true;end;
	if getServer() then return;end;
	VehicleInspector.firstLoad = false;
	VehicleInspector.controlledVehicle = 0;
	VehicleInspector.controlledVehicleShortName = "N";
	VehicleInspector.controlledName = "Unknown";
	VehicleInspector.foundMaxAttached = 0;
	VehicleInspector.foundGroupManager = false;
	VehicleInspector.foundVehicleWarnings = 0;
	VehicleInspector.maxAttachedVehicleWarnings = 0;	
	VehicleInspector.modMenue = 0;
	VehicleInspector.modMenueName = "VehicleInspector";
	VehicleInspector.modMenueIsOpen = false;
	loadScripts(self);	
	viGui:setGetGuiLoadTables(self);
	viSetGetConfigXml:loadConfig(self,getServer());
	viGui:loadAllOverlays(self);
	viExtras:loadFieldDef(self);		
	--viExtras:searchMods(self);
	viGui:setGetHotSpotMap(self, true, nil);
	if g_currentMission.guiMenue ~= nil then		
		guiMenueSettings:generateGuiMenue(self);
		guiMenueSettings:getYourMenue(self, VehicleInspector.modMenueName);
	end;
end;

function VehicleInspector:deleteMap()
	if getServer() then return;end;
	viGui:deleteAllOverlays(self);
	viSetGetConfigXml:saveConfig()
end;

function VehicleInspector:mouseEvent(posX, posY, isDown, isUp, button)	
	if getServer() or getFullSize() or getIngameMap() or isMohPageOpen() then return;end;
	if not VehicleInspector:getFrozenMouseControlled() then return;end;
	viKeyMouseEvents:setKeyMouse(self, nil, nil, nil, nil, posX, posY, isDown, isUp, button);
end;

function VehicleInspector:keyEvent(unicode, sym, modifier, isDown)
	if getServer() or getFullSize() or getIngameMap() or isMohPageOpen() then return;end;
	--if VehicleInspector:getFrozenMouseControlled() then return;end;
	viKeyMouseEvents:setKeyMouse(self, unicode, sym, modifier, isDownKey, nil, nil, nil, nil, nil);
end;

function VehicleInspector:updateTick(dt)	
	if getServer() or getFullSize() or getIngameMap() then return;end;	
end;

function VehicleInspector:update(dt)
	if getServer() or getFullSize() or getIngameMap() then setVehicleControlledRootNode(true);return;end;
	if not VehicleInspector.firstLoad then VehicleInspector.firstLoad = true;setInputBinding();viExtras:searchMods(self);end;
	if g_currentMission.vi ~= nil and g_currentMission.vi.isOn then 
		if g_currentMission.vi.isMouseCursor then InputBinding.setShowMouseCursor(true);end;
		if g_currentMission.vi.setFrozen and g_currentMission.vi.isFrozen then g_currentMission.isPlayerFrozen = true;end;
	end;
	if guiMenueSettings:isOpen(self) then
		if viGui.defaultHud.mouseCursorCloseSettingsAutoOff then VehicleInspector.modMenueIsOpen = true;end;
		if guiMenueSettings:getSave(self) then guiMenueSettings:setSave(self);end;
		if guiMenueSettings:getClick(self) then guiMenueSettings:setClick(self);end;
	elseif VehicleInspector.modMenueIsOpen and viGui.defaultHud.mouseCursorCloseSettingsAutoOff and not g_currentMission.guiMenue.on then
		if g_currentMission.vi.frozenAndCursorOverMoh and g_currentMission.vi.Moh ~= nil and g_currentMission.vi.Moh.table ~= nil and g_currentMission.vi.Moh.table.moGeneralSettings ~= nil then
			VehicleInspector.modMenueIsOpen = false;			
			g_currentMission.vi.isMouseCursor = false;
			g_currentMission.vi.Moh.table.moGeneralSettings.setMouseCursor = false;
			g_currentMission.vi.Moh.table.moGeneralSettings.setFrozen = false;
			InputBinding.setShowMouseCursor(false);
			if g_currentMission.vi.setFrozen then g_currentMission.vi.isFrozen = false;g_currentMission.isPlayerFrozen = false;end;
		else
			VehicleInspector.modMenueIsOpen = false;
			g_currentMission.vi.isMouseCursor = false;				
			InputBinding.setShowMouseCursor(false);			
			if g_currentMission.vi.setFrozen then g_currentMission.vi.isFrozen = false;g_currentMission.isPlayerFrozen = false;end;
		end;
	end;
	setVehicleControlledRootNode(false);
	if getInputEvent(self) then return;end;	
end;

function VehicleInspector:draw()	
	if getServer() or getFullSize() or getIngameMap() or isMohPageOpen() then onCloseDrawOrAreas(self,true,true,true);return;end;
	if viGui.defaultHud.seeAnimals.on then viDraw:setOpenAnimals(self);end;
	if not g_currentMission.vi.isOn then onCloseDrawOrAreas(self,true,false,false);return;end;
	if not g_currentMission.guiMenue.on or (g_currentMission.guiMenue.on and g_currentMission.guiMenue.modMenue ~= VehicleInspector.modMenue) then 
		onCloseDrawOrAreas(self,false,false,true);
	--elseif g_currentMission.guiMenue.on and g_currentMission.guiMenue.modMenue == VehicleInspector.modMenue and not viGui.settingsOnViMenue.dragDropPos then		
	--	viGui.settingsOnViMenue.dragDropPos = true;
	--	viMouseClickAreas:setMenueCfg(self);
	end;
	if viGui.defaultHud.hotSpot and VehicleInspector.hotSpotMap.visible then
		VehicleInspector.hotSpotMap.timer = VehicleInspector.hotSpotMap.timer+1;
		if VehicleInspector.hotSpotMap.timer > viGui.defaultHud.timer["isTimer2"] then viGui:setGetHotSpotMap(self, false, false, 0, 0);end;
	end;
	--viGui["screenTest"]:render();
	setViPos();
	viDraw:setOpenPDA(self);
	if viGui.settingsOnViMenue.dragDropPos or viGui.defaultHud.seeAnimals.dragDrop then			
		viGui["dragDropGround"]:render();
	end;
	if (viGui.helpText.on or viGui.helpText.vehicleInfo) and VehicleInspector:getFrozenMouseControlled() then
		if string.len(viGui.helpText.txt) > 0 and (viGui.helpText.posX ~= 0 or viGui.helpText.posY ~= 0) then
			setTextBold(true);
			setTextColor(unpack(viGui.helpText.color));
			local txtHeight = getTextHeight(viGui.helpText.size, tostring(viGui.helpText.txt));
			local txtWidth = getTextWidth(viGui.helpText.size, tostring(viGui.helpText.txt))
			local txtHeightLine = getTextHeight(viGui.helpText.size, tostring("----Test----"));
			if viGui.helpText.posY+(txtHeight-txtHeightLine) > 0.99 then
				viGui.helpText.posY = 0.99-(txtHeight);			
			end;
			if viGui.helpText.posX+(txtWidth) > 0.99 then
				viGui.helpText.posX = 0.99-(txtWidth);			
			end;
			viGui:setOverlay(self, viGui["helpGround"], viGui.helpText.posX, viGui.helpText.posY-0.002, txtWidth, txtHeight);			
			viGui["helpGround"]:render();			
			renderText(viGui.helpText.posX, viGui.helpText.posY+(txtHeight-txtHeightLine), viGui.helpText.size, tostring(viGui.helpText.txt));
		end;
	end;
	local vehicle = g_currentMission.nodeToVehicle[VehicleInspector.controlledVehicle];
	if vehicle ~= nil then
		--renderText(0.3, 0.9, 0.012, "isAttached:".. tostring(vehicle.viAttachedTable.isAttached).. " - hard:".. tostring(#vehicle.viAttachedTable.hardAttached).. " - front:".. tostring(#vehicle.viAttachedTable.frontAttached).. " - back:".. tostring(#vehicle.viAttachedTable.backAttached));
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;
addModEventListener(VehicleInspector);

function onCloseDrawOrAreas(self,one,two,three)
	if getServer() then return;end;
	if one then viGui.defaultHud.clickArea = {};end;
	if two then viGui.defaultHud.clickAreaAnimals = {};end;
	if three then viGui.settingsOnViMenue.dragDropPos = false;viGui.settingsGuiMenue.on=false;end;
end;

function getFullSize()
	if g_currentMission.paused or 
	g_currentMission.manualPaused or
	g_inGameMenu.isOpen or
	g_currentMission.physicsPaused then 
	if VehicleInspector.isMp and g_currentMission.manualPaused then return false;end; --patch 1.3 bug !!
	return true;end;
	return false;
end;

function getIngameMap()
	if g_currentMission.ingameMap.isVisible and g_currentMission.ingameMap.state == 1 then return true;end;
	return false;
end;

function getIngameMapState()
	if g_currentMission.ingameMap.isVisible and g_currentMission.ingameMap.state == 0 then return false;end;
	if not g_currentMission.ingameMap.isVisible and g_currentMission.ingameMap.state == 0 then return false;end;
	return true;
end;

function getIngameHelpMenu()
	return g_gameSettings:getValue("showHelpMenu");
end;

function getServer()
	--if (g_server ~= nil and g_client ~= nil) or (g_client ~= nil and g_server == nil) then return false;end;	
	return VehicleInspector.loadDetiServer;
end;

function setVehicleControlledRootNode(delete)
	if getServer() then return;end;
	if not delete and g_currentMission.controlledVehicle ~= nil and Utils.getNoNil(g_currentMission.controlledVehicle.isControlled, false) and Utils.getNoNil(g_currentMission.controlledVehicle.controllerName, "") == g_currentMission.player.controllerName then
		VehicleInspector.controlledVehicle = g_currentMission.controlledVehicle.rootNode;
	else
		VehicleInspector.controlledVehicle = 0;
	end;
end;

function setViPos()
	if viGui.defaultHud.pos == 1 or viGui.defaultHud.pos == 2 or viGui.defaultHud.pos == 3 then		
		--if (g_currentMission.showHelpText and g_currentMission.helpBoxContentOverlay.y ~= nil) and (#g_currentMission.helpButtonTexts > 0) or (g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.controllerName == g_currentMission.player.controllerName and g_currentMission.controlledVehicle.typeDesc == "Crane") then
		if (getIngameHelpMenu() and g_currentMission.helpBoxContentOverlay.y ~= nil) and (#g_currentMission.helpButtonTexts > 0) then --or (g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.controllerName == g_currentMission.player.controllerName and g_currentMission.controlledVehicle.typeDesc == "Crane" and g_gameSettings:getValue("showHelpMenu")) then
			local cruise = 0;
			local cruise1 = 0;
			if (g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.controllerName == g_currentMission.player.controllerName) and g_currentMission.controlledVehicle.typeDesc == "Crane" then
				--cruise = g_currentMission.cruiseControlOverlay.height;
				--cruise1 = g_currentMission.cruiseControlOverlay.height;
			end;			
			if viGui.defaultHud.pos == 2 then
				viGui.defaultHud.posX = g_currentMission.helpBoxContentOverlay.x+g_currentMission.helpBoxContentOverlay.width;
				viGui.defaultHud.posY = g_currentMission.helpBoxContentOverlay.y+((viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5)*2)+g_currentMission.helpBoxContentOverlay.height; --+0.01+cruise1;
			else
				if viGui.settingsOnViMenue.isLockDefaultHud then
					viGui.defaultHud.posY = g_currentMission.helpBoxContentOverlay.y+0.005-cruise; --helpBoxHeaderBgOverlay
				else
					viGui.defaultHud.posY = g_currentMission.helpBoxContentOverlay.y-0.005-cruise;
				end;
				viGui.defaultHud.posX = 0.0015;
			end;
			--if g_currentMission.hudHelpTextLineSpacing ~= 0 then moSetGetGui.pdaVI.posY = moSetGetGui.pdaVI.posY - g_currentMission.hudHelpTextLineSpacing*2;end;
		else
			local badPos = viGui.defaultHud.seeAnimals.posY >= 0.995 and viGui.defaultHud.seeAnimals.posX <= 0.23;
			if (viGui.defaultHud.seeAnimals.on and not viGui.settingsOnViMenue.isLockDefaultHud and badPos) then
				viGui.defaultHud.posY = 0.994-(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);			
			elseif (viGui.defaultHud.seeAnimals.on and viGui.settingsOnViMenue.isLockDefaultHud and badPos) then
				viGui.defaultHud.posY = 0.994;
			else
				viGui.defaultHud.posY = 0.999;
			end;			
			viGui.defaultHud.posX = 0.0015;
		end;
	elseif viGui.defaultHud.pos == 4 or viGui.defaultHud.pos == 5 or viGui.defaultHud.pos == 6 then
		if g_currentMission.ingameMap.isVisible and g_currentMission.ingameMap.state == 0 then			
			if viGui.defaultHud.pos == 4 then
				viGui.defaultHud.posY = 0.002; --g_currentMission.ingameMap.mapPosY;
				viGui.defaultHud.posX = g_currentMission.ingameMap.mapPosX+g_currentMission.ingameMap.minMapWidth;
			else
				viGui.defaultHud.posY = g_currentMission.ingameMap.mapPosY+g_currentMission.ingameMap.minMapHeight;
				viGui.defaultHud.posX = 0.0015;
			end;
		else			
			local badPos = viGui.defaultHud.seeAnimals.posY <= 0.01+(viGui.buttonGfxHeight1*3.5*5) and viGui.defaultHud.seeAnimals.posX <= 0.23;
			if (viGui.defaultHud.seeAnimals.on and badPos) then
				viGui.defaultHud.posY = 0.002+(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
			else
				viGui.defaultHud.posY = 0.002;				
			end;
			viGui.defaultHud.posX = 0.0015;
		end;
	end;
end;

function isMohPageOpen()	
	if not g_currentMission.vi.foundMoh	then 
		return false;
	elseif g_currentMission.vi.Moh ~= nil and g_currentMission.vi.Moh.table ~= nil and g_currentMission.vi.Moh.table.moSetGetGui ~= nil then
		return Utils.getNoNil(g_currentMission.vi.Moh.table.moSetGetGui.isActivePage,false);
	end;
	return false;
end;

function VehicleInspector:getFrozenMouseControlled()	
	if g_currentMission.vi.foundMoh and g_currentMission.vi.frozenAndCursorOverMoh and g_currentMission.vi.Moh ~= nil and g_currentMission.vi.Moh.table ~= nil and g_currentMission.vi.Moh.table.moGeneralSettings ~= nil then
		return Utils.getNoNil(g_currentMission.vi.Moh.table.moGeneralSettings.setMouseCursor, false);
	else
		return g_currentMission.vi.isMouseCursor;
	end;
end;

function setInputBinding()
	viGui.binding.onOff = Utils.getNoNil(VehicleInspector:getKeyIdOfModifier(InputBinding.VI_OnOff, false));
	viGui.binding.hiddenOnOff = Utils.getNoNil(VehicleInspector:getKeyIdOfModifier(InputBinding.VI_Hidden, false));
	viGui.binding.mouseOnOff = Utils.getNoNil(VehicleInspector:getKeyIdOfModifier(InputBinding.VI_OnOffMouseCursor, false));
	viGui.binding.mouseOnOffMoh = Utils.getNoNil(VehicleInspector:getKeyIdOfModifier(InputBinding.MoV2OnOffMouseCursor, false));	
	viGui.binding.keySelectUp = Utils.getNoNil(VehicleInspector:getKeyIdOfModifier(InputBinding.VI_KeySelectUp, false));
	viGui.binding.keySelectDown = Utils.getNoNil(VehicleInspector:getKeyIdOfModifier(InputBinding.VI_KeySelectDown, false));
	viGui.binding.keySelectAction = Utils.getNoNil(VehicleInspector:getKeyIdOfModifier(InputBinding.VI_KeySelectAction, false));
	if g_currentMission.vi ~= nil and viGui.binding.mouseOnOff then			
		for key,value in pairs(Input) do
			if value == viGui.binding.mouseOnOff then
				g_currentMission.guiMenue.mod[tostring(VehicleInspector.modMenueName)].page[1].buttons[9][2].buttonCmdTableValue = tostring(key);
				break;
			end;
		end;
	end;
	if (not viGui.binding.keySelectUp and not viGui.binding.keySelectDown) or not viGui.binding.keySelectAction then viGui.defaultHud.vehicleSettingsKeySelect.on = false;end;
end;

function VehicleInspector:getKeyIdOfModifier(binding)
    local bindingFound = nil;	
	if InputBinding.actions[binding] ~= nil then
		for key, value in pairs(InputBinding.actions[binding]) do
			--if key == "keys1" or key == "keys2" or key == "mouseButtons" or key == "gamepadButtons" then
			if key == "keys1" or key == "keys1Set" or key == "keys2" or key == "keys2Set" or key == "mouseButtons" or key == "gamepadButtons" then			
				bindingFound = value[1];
				if bindingFound ~= nil then break;end;
			end;
		end;
	end;
    return bindingFound;
end;

function getInputEvent(self)
	if (viGui.binding.onOff and InputBinding.hasEvent(InputBinding.VI_OnOff)) or 
	    (viGui.binding.hiddenOnOff and InputBinding.hasEvent(InputBinding.VI_Hidden)) or
		InputBinding.hasEvent(InputBinding.VI_KeySelectUp) or
		InputBinding.hasEvent(InputBinding.VI_KeySelectDown) or
		InputBinding.hasEvent(InputBinding.VI_KeySelectAction) or
		(g_currentMission.vi.frozenAndCursorOverMoh and viGui.binding.mouseOnOffMoh and InputBinding.hasEvent(InputBinding.MoV2OnOffMouseCursor)) or
		(not g_currentMission.vi.frozenAndCursorOverMoh and viGui.binding.mouseOnOff and InputBinding.hasEvent(InputBinding.VI_OnOffMouseCursor)) then				
		return true;		
	end;
	return false;
end;

function loadScripts(self)
	source(VehicleInspector.modDir.."viGui.lua");		
	source(VehicleInspector.modDir.."viExtras.lua");
	source(VehicleInspector.modDir.."viDraw.lua");
	source(VehicleInspector.modDir.."viKeyMouseEvents.lua");
	source(VehicleInspector.modDir.."viSetGetConfigXml.lua");
	source(VehicleInspector.modDir.."viSetGet.lua");
	--source(VehicleInspector.modDir.."viMouseClickAreas.lua");
	source(VehicleInspector.modDir.."viDragDrop.lua");
	source(VehicleInspector.modDir.."guiMenueSettings.lua");
end;

function VehicleInspector:mouseIsInArea(mouseX, mouseY, areaX1, areaX2, areaY1, areaY2)
	return mouseX >= areaX1 and mouseX <= areaX2 and mouseY >= areaY1 and mouseY <= areaY2;
end;

function VehicleInspector:tableToString(tt, indent, done)
	--print(tostring(MultiOverlayV2:tableToString(...)));
	--for key, value in pairs(.....) do
	--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
	--end;	
	done = done or {};
	indent = indent or 0;
	if type(tt) == "table" then
		local sb = {}
		for key, value in pairs (tt) do
			table.insert(sb, string.rep (" ", indent));
			if type (value) == "table" and not done [value] then
				done [value] = true;
				table.insert(sb, "{\n");
				table.insert(sb, MultiOverlayV2:tableToString (value, indent + 2, done));
				table.insert(sb, string.rep (" ", indent));
				table.insert(sb, "}\n");
			elseif "number" == type(key) then
				table.insert(sb, string.format("\"%s\"\n", tostring(value)));
			else
				table.insert(sb, string.format("%s = \"%s\"\n", tostring(key), tostring(value)));
			end
		end
		return table.concat(sb);
	else
		if tt == nil then return "table error.........";end;
		return tt .. "\n";
	end;
end;