viExtras = {};

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;
function viExtras:loadFieldDef(self)
	viFieldDef = {};
	function getFieldValues(fieldDef)
		local fieldValues = {};
		if fieldDef ~= nil and fieldDef.fieldDimensions ~= nil then			
			local mapIndicatorX = 0;
			local mapIndicatorZ = 0;
			if fieldDef.fieldMapIndicator ~= nil then
				local wx, _, wz = getWorldTranslation(fieldDef.fieldMapIndicator);
				if wx ~= nil and wz ~= nil then
					mapIndicatorX = wx;
					mapIndicatorZ = wz;
				end;
			end;
			local cornerPoints = false;
			for a=0, getNumOfChildren(fieldDef.fieldDimensions) - 1 do
				local b1 = getChildAt(fieldDef.fieldDimensions, a);
				local b2 = getChildAt(b1, 0);
				local b3 = getChildAt(b1, 1);
				local c1 = { getWorldTranslation(b1) };
				local c2 = { getWorldTranslation(b2) };
				local c3 = { getWorldTranslation(b3) };
				--local overlap = 2; --VI !!
				local x1 = min(c1[1],c2[1],c3[1]) --- overlap;
				local z1 = min(c1[3],c2[3],c3[3]) --- overlap;
				local x2 = max(c1[1],c2[1],c3[1]) --+ overlap;
				local z2 = max(c1[3],c2[3],c3[3]) --+ overlap;								
				if not cornerPoints and mapIndicatorX >= x1 and mapIndicatorX <= x2 and mapIndicatorZ >= z1 and mapIndicatorZ <= z2 then						
					cornerPoints = true;
				end;				
				table.insert(fieldValues, {x1=x1,z1=z1,x2=x2,z2=z2,mapIndicatorX=mapIndicatorX,mapIndicatorZ=mapIndicatorZ,cornerPoints=cornerPoints});				
			end;			
		end;
		return fieldValues;
	end;
	for fieldNumber,fieldDef in ipairs(g_currentMission.fieldDefinitionBase.fieldDefs) do				
		viFieldDef[fieldNumber] = {};				
		--if fieldDef.fieldMapIndicator ~= nil then
		--	local wx, _, wz = getWorldTranslation(fieldDef.fieldMapIndicator);
		--	if wx ~= nil and wz ~= nil then
		--		moFieldMapIndicator[fieldNumber] = {};
		--		moFieldMapIndicator[fieldNumber].x = wx;
		--		moFieldMapIndicator[fieldNumber].z = wz;						
		--	end;
		--end;
		viFieldDef[fieldNumber] = getFieldValues(fieldDef);					
	end;
end;

function viExtras:createTimers(self)	
	local lenght = 500;
	local isTimersLenght = 0;
	local maxTimers = 50;
	viGui.defaultHud.timer = {};
	for a=0, maxTimers do		
		viGui.defaultHud.timer["isTimer".. a] = 0;
		if a == 0 then
			viGui.defaultHud.timer["timer".. a] = 250;
		else
			isTimersLenght = isTimersLenght+lenght;
			viGui.defaultHud.timer["timer".. a] = isTimersLenght;
		end;		
	end;
	viGui.defaultHud.timer["getTimers"] = maxTimers;
end;

function viExtras:setTimers(self)	
	for a=0, viGui.defaultHud.timer.getTimers do		
		--print("set Timer...".. tostring(a))
		viGui.defaultHud.timer["isTimer".. a] = viGui.defaultHud.timer["isTimer".. a]+1;
		if viGui.defaultHud.timer["isTimer".. a] >= viGui.defaultHud.timer["timer".. a] then
			viGui.defaultHud.timer["isTimer".. a] = 0;
			--print("reset Timer...".. tostring(a))
		end;
	end;
end;

function viExtras:searchMods(self)
	local foundMoh = false;	
	local foundGV = false;
	local env = getfenv(0);	
	for modName,isLoaded in pairs(g_modIsLoaded) do
		--print("modname.....".. tostring(modName))
		if isLoaded then			
			if not foundMoh and env[modName] ~= nil and env[modName]["MultiOverlayV2"] ~= nil then
				--print("found  MultiOverlayV2.............")
				g_currentMission.vi.foundMoh = true;				
				if (g_currentMission.mohIsLoad ~= nil and not g_currentMission.mohIsLoad) or g_currentMission.mohIsLoad == nil then
					g_currentMission.vi.foundMoh = false;
				else
					g_currentMission.vi.Moh = {};
					if env[modName].moGeneralSettings == nil then 
						g_currentMission.vi.Moh.table = env[modName].MultiOverlayV2;
					else
						g_currentMission.vi.Moh.table = env[modName];
					end;
					if g_currentMission.vi.Moh.table.moGeneralSettings == nil then
						g_currentMission.vi.foundMoh = false;
					end;
				end;
				foundMoh = true;
				--for k, v in pairs(g_currentMission.vi.Moh.table) do
				--	print("g_currentMission.vi.Moh.table k und v ...".. tostring(k).. "-----".. tostring(v))									
				--end;
			end;
			if not foundGV and env[modName] ~= nil and (env[modName]["VehicleGroupsSwitcher"] ~= nil or env[modName]["FS17_DCK_VehicleGroupsSwitcher"] ~= nil) then				
				VehicleInspector.foundGroupManager = true;
				foundGV = true;
			end;
		end;
	end;
	if not g_currentMission.vi.foundMoh then 
		g_currentMission.vi.frozenAndCursorOverMoh = false;
	else
		if viGui.binding.mouseOnOffMoh and viGui.binding.mouseOnOff == viGui.binding.mouseOnOffMoh then
			g_currentMission.vi.frozenAndCursorOverMoh = true;
		else
			g_currentMission.vi.frozenAndCursorOverMoh = false;
		end;
	end;
end;

function viExtras:getMilliSecondsToHours(sMilliSeconds, getHoursMin, getHoursSec)
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == nil or nMilliSeconds == 0 then	
		return "0";
	else
		local nHours = string.format("%02.f", floor(nMilliSeconds/3600000));
		local nMins = string.format("%02.f", floor(nMilliSeconds/60000 - (nHours*60)));	
		local nSecs = string.format("%02.f", floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));
		if not getHoursMin then return nHours;end;				
		if getHoursMin and getHoursSec == nil then return nHours..":"..nMins;end;
		if getHoursMin and getHoursSec then return nHours..":"..nMins..":"..nSecs;end;
	end;
	return "0";
end;

viExtras.colors = {		
	darkYellow =   		{ 255/255, 161/255,  17/255, 1.00 };
	darkYellowOff =  	{ 255/255, 161/255,  17/255, 0.80 };
	white =         	{ 255/255, 255/255, 255/255, 1.00 };
	whiteBestPrice =	{ 255/255, 255/255, 255/255, 1.00 };
	whiteInactive = 	{ 255/255, 255/255, 255/255, 0.75 };
	whiteDisabled = 	{ 255/255, 255/255, 255/255, 0.15 };
	hover =         	{   4/255,  98/255, 180/255, 1.00 };
	hoverBestPrice =	{   4/255,  98/255, 180/255, 0.70 };
	darkBlue =	 		{ 	0/255,   0/255, 255/255, 1.00 };
	darkBlueInactive =	{ 	0/255,   0/255, 255/255, 0.75 };
	darkBlueDisabled =	{ 	0/255,   0/255, 255/255, 0.15 };
	activeGreen =   	{  43/255, 205/255,  10/255, 1.00 }; 
	activeRed =    	 	{ 153/255,  22/255,  19/255, 1.00 };
	activeRedInactive = { 153/255,  22/255,  19/255, 0.75 };
	activeRedDisabled = { 153/255,  22/255,  19/255, 0.15 };
	closeRed =      	{ 116/255,   0/255,   0/255, 1.00 }; 
	warningRed =    	{ 222/255,   2/255,   3/255, 1.00 };
	red =      			{ 255/255,   0/255,   0/255, 1.00 };
	redDisabled =   	{ 255/255,   0/255,   0/255, 0.80 };
	shadow =        	{   4/255,   4/255,   4/255, 1.00 }; 
	textDark =      	{   1/255,   1/255,   1/255, 1.00 };
	yellowGround =      { 255/255, 255/255,   0/255, 1.00 };
	yellowGroundInactive ={ 255/255, 255/255,   0/255, 0.75 };
	yellowGroundDisabled ={ 255/255, 255/255,   0/255, 0.15 };
	yellow =        	{ 255/255, 255/255,   0/255, 1.00 };
	yellowDisabled =	{ 255/255, 255/255,   0/255, 0.80 };
	yellowGreen =		{ 154/255, 205/255,  50/255, 1.00 };
	yellow1 =			{ 238/255, 221/255, 130/255, 1.00 };
	gold =				{ 255/255, 215/255,   0/255, 1.00 };
	goldInactive =		{ 255/255, 215/255,   0/255, 0.75 };
	goldDisabled =		{ 255/255, 215/255,   0/255, 0.15 };
	green =        		{ 	0/255, 255/255,   0/255, 1.00 };
	darkOliveGreen =    {  85/255, 107/255,  47/255, 1.00 };
	greenDisabled = 	{ 	0/255, 255/255,   0/255, 0.80 };
	darkGreen = 		{ 	0/255, 100/255,   0/255, 1.00 };
	darkGreenInactive = { 	0/255, 100/255,   0/255, 0.75 };
	darkGreenDisabled = { 	0/255, 100/255,   0/255, 0.15 };	
	lightGreen =   		{ 144/255, 238/255, 144/255, 1.00 };
	chartreuse4 =		{ 69/255,  139/255,   0/255, 1.00 };
	chartreuse4Inactive ={ 69/255,  139/255,   0/255, 0.75 };
	chartreuse4Disabled ={ 69/255,  139/255,   0/255, 0.15 };
	happylooser =   	{ 143/255, 188/255, 143/255, 1.00 };---
	happylooserOff= 	{ 143/255, 188/255, 143/255, 0.80 };---
	gray = 				{ 190/255, 190/255, 190/255, 1.00 };
	grayInactive = 		{ 190/255, 190/255, 190/255, 0.75 };
	grayDisabled = 		{ 190/255, 190/255, 190/255, 0.15 };
	black =        		{ 	0/255,   0/255,   0/255, 1.00 };
	blackDisabled = 	{ 	0/255, 	 0/255,   0/255, 0.15 };
	blackInactive = 	{ 	0/255, 	 0/255,   0/255, 0.75 };
	orange =        	{ 255/255, 165/255,   0/255, 1.00 };
	orangeInactive =    { 255/255, 165/255,   0/255, 0.75 };
	orangeDisabled =    { 255/255, 165/255,   0/255, 0.15 };
	orangeRed =        	{ 255/255,  55/255,   0/255, 1.00 };
	orangeRedInactive = { 255/255,  55/255,   0/255, 0.75 };
	orangeRedDisabled = { 255/255,  55/255,   0/255, 0.15 };
	khaki =         	{ 240/255, 230/255, 140/255, 1.00 };
	khakiInactive =     { 240/255, 230/255, 140/255, 0.75 };
	khakiDisabled =     { 240/255, 230/255, 140/255, 0.15 };
	ls15 =          	{   0/255, 255/255, 255/255, 1.00 };
	ls15Disabled =  	{   0/255, 255/255, 255/255, 0.80 };
	ls15Ground =        {   0/255, 255/255, 255/255, 1.00 };
	ls15GroundInactive = {   0/255, 255/255, 255/255, 0.75 };
	ls15GroundDisabled = {   0/255, 255/255, 255/255, 0.15 };
	mangenta =  		{ 255/255, 	 0/255, 255/255, 1.00 };
	mangentaInactive =  { 255/255, 	 0/255, 255/255, 0.75 };
	mangentaDisabled =  { 255/255, 	 0/255, 255/255, 0.15 };
	deepPink =  		{ 255/255, 020/255, 147/255, 1.00 };
	deepPinkInactive =  { 255/255, 020/255, 147/255, 0.75 };
	deepPinkDisabled =  { 255/255, 020/255, 147/255, 0.15 };
	purple =  			{ 160/255, 032/255, 240/255, 1.00 };
	purpleInactive =  	{ 160/255, 032/255, 240/255, 0.75 };
	purpleDisabled =  	{ 160/255, 032/255, 240/255, 0.15 };
};